/*
 * $Id: Parameters.cpp 113 2009-04-14 18:39:12Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/Comparator/include/Parameters.h"
#include "Common/include/BitManipulation.h"

namespace morpheo {
namespace behavioural {
namespace generic {
namespace comparator {

#undef  FUNCTION
#define FUNCTION "Comparator::Parameters"
  Parameters::Parameters (uint32_t             size_data,
                          bool                 is_signed,
                          Tcomparator_scheme_t type     ,
                          bool is_toplevel)
  {
    log_begin(Comparator,FUNCTION);

    _size_data = size_data;
    _is_signed = is_signed;
    _type      = type     ;

    test();

    _extends   = gen_mask_not<int64_t>(_size_data);
    _mask_sign = (1<<(_size_data-1));

    if (is_toplevel)
      {
        copy();
      }

    log_end(Comparator,FUNCTION);
  };
  
// #undef  FUNCTION
// #define FUNCTION "Comparator::Parameters (copy)"
//   Parameters::Parameters (Parameters & param)
//   {
//     log_begin(Comparator,FUNCTION);
//     test();
//     log_end(Comparator,FUNCTION);
//   };

#undef  FUNCTION
#define FUNCTION "Comparator::~Parameters"
  Parameters::~Parameters (void) 
  {
    log_begin(Comparator,FUNCTION);
    log_end(Comparator,FUNCTION);
  };

#undef  FUNCTION
#define FUNCTION "Comparator::copy"
  void Parameters::copy (void) 
  {
    log_begin(Comparator,FUNCTION);
    log_end(Comparator,FUNCTION);
  };

}; // end namespace comparator
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
